/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2010 Oracle and/or its affiliates. All rights reserved.
 *
 * Oracle and Java are registered trademarks of Oracle and/or its affiliates.
 * Other names may be trademarks of their respective owners.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */



package org.netbeans.test.umllib.util;

public class PopupConstants {
    
    //top level items
    public final static String EDIT = "Edit";
    public final static String FIND = "Find";
    public final static String RESET_ELEMENT_TO_CONTENTS = "Resize Element to Contents";
    public final static String RESET_EDGES = "Reset Edges";
    public final static String HIDE = "Hide";
    public final static String SHOW = "Show";
    public final static String LABELS = "Labels";
    public final static String COLORS_FONTS = "Colors & Fonts";
    
    //edit section
    public final static String COPY = "Copy";
    public final static String PASTE = "Paste";
    public final static String DELETE = "Delete";
    public final static String CUT = "Cut";
    public final static String LOCK_EDIT = "Lock Edit";
    public final static String SELECT_ALL = "Select All";
    public final static String SELECT_ALL_SIMILAR = "Select All Similar Elements";
    public final static String INVERT_SELECTION = "Invert Selection";
    public final static String SET_DIMESIONS = "Set Dimensions...";
    
    //Find section
    public final static String ELEMENT_IN_PROJECT_TREE = "Element In Project Tree";
    public final static String SOURCE_ELEMENT = "Source Element";
    public final static String TARGET_ELEMENT = "Target Element";
    
    //hide section
    public final static String CHILDREN = "Children";
    public final static String PARENTS = "Parents";
    public final static String ONE_LEVEL = "One Level";
    public final static String ALL_LEVELS = "All Levels";
    
    
    //Font and colors section
    public final static String FONT = "Font";
    public final static String FONT_COLOR = "Foreground";
    public final static String BACKGROUND = "Background";
    public final static String BORDER_COLOR = "Border Color";
    
    //Labels section
    public final static String NAME = "Name";
    public final static String RESET_LABELS = "Reset Labels";
    
    // Contextual menus on UML project Tree node - class diagram node
    public final static String OPEN  = "Open";
    public final static String ADD   = "Add";
    public final static String SAVE  = "Save";
    public final static String CLOSE = "Close";
    public final static String NODE_DELETE = "Delete";
    public final static String RENAME = "Rename...";
    public final static String NAVIGATE_TO_SOURCE = "Navigate To Source";
     public final static String SOURCE_CONTROL_REFRESH_STATUS = "SourceControl|Refresh Status";
    
    // Contextual menus on UML project Tree node - Model node
    public final static String OPEN_REQUIRED_PROJECTS  = "Open Required Projects";
    public final static String CLOSE_PROJECT = "Close Project";
    public final static String ADD_DIAGRAM = "New|Diagram";
    public final static String ADD_PACKAGE = "New|Package";
    public final static String ADD_ELEMENT = "New|Element";
    public final static String ADD_ATTRIBUTE= "New|Attribute";
    public final static String ADD_OPERATION= "New|Operation";
    public final static String FILTER = "Filter...";
    
    
    
    // Contextual menus specific to class element
    public final static String INSERT_ATTRIBUTE  = "Insert Attribute";   
    public final static String DELETE_ATTRIBUTE  = "Delete Attribute";
    public final static String INSERT_OPERATION  = "Insert Operation";
    public final static String DELETE_OPERATION  = "Delete Operation";

    public final static String GENERATE_DEPENDENCY_DIAGRAM  = "Generate Dependency Diagram";
    public final static String REVERSE_ENGINEER_OPERATION  = "Reverse Engineer Operation...";

}
